#ifndef CONTROLLER_H
#define CONTROLLER_H
#include <QGLWidget>
#include <gl/GLU.h>
#include <QDebug>
#include <QWheelEvent>
#include <QQuaternion>
#include <QMatrix4x4>
#include <math.h>
#include <QVector3D>
#include <QGLShaderProgram>
#include <QGLShader>
#include <QDebug>
#include <QObject>

class MyGLWidget;

class Controller : public QObject
{
    Q_OBJECT

public:
    Controller();
    ~Controller();


    //processes input and might call follow up functions in widget
    void processMousePressEvent(QMouseEvent* event, MyGLWidget* widget);

    //processes mouse movement, calls some translate / rotate function in widget
    void processMouseMoveEvent(QMouseEvent* event, MyGLWidget* widget);

    void setScreenScenter(QPoint center);
private:
    bool modeCamera;

    bool rightButtonPressed;
    bool leftButtonPressed;
    QPoint screenCenter;//Center of screen in pixel coordinates
    QPoint lastClickPosition;

    QQuaternion computeRotation(QPoint newPosition);


public slots:
    void switchToModeCamera();
    void switchToModeManipulate();

};

#endif // CONTROLLER_H
